



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Shell中字符串分割的三种方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Shell中字符串分割的三种方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-19 13:04:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>问题：对于&rsquo;1,2,3,4,5&rsquo;这样的字符串输出采用,分隔开的1&nbsp;2&nbsp;3&nbsp;4&nbsp;5</p>
<p>特征：在字符串中没有空格</p>
<p>解决方法1：</p>
<div>
<ol><li>#!/bin/bash</li>
<li>var=&rsquo;1,2,3,4,5&rsquo;</li>
<li>var=${var//,/&nbsp;}&nbsp;&nbsp;&nbsp;&nbsp;#这里是将var中的,替换为空格</li>
<li>for&nbsp;element&nbsp;in&nbsp;$var</li>
<li>do</li>
<li>echo&nbsp;$element</li>
<li>done</li></ol>
</div>
<p>若原来字符串中有空格如：&rsquo;mark:x:0:0:this&nbsp;is&nbsp;a&nbsp;test&nbsp;user:/var/mark:nologin&rsquo;这样的字符串，要将:分隔的字符串输出，上面的方法会将this&nbsp;is&nbsp;a&nbsp;test&nbsp;user分别输出，这个是不对的。</p>
<p>对于这种情况解决方法2：</p>
<div>
<ol><li>#!/bin/bash</li>
<li>user=&rsquo;mark:x:0:0:this&nbsp;is&nbsp;a&nbsp;test&nbsp;user:/var/mark:nologin&rsquo;</li>
<li>for((i=1;i&lt;=7;i++))</li>
<li>do</li>
<li>echo&nbsp;$user|cut&nbsp;-d&nbsp;":"&nbsp;-f$i</li>
<li>done</li></ol>
</div>
<p>上面这种方法是确定字符串分隔后的长度的，要是写的更通用一点，向下面这样</p>
<p>解决方法3：</p>
<div>
<div>
<ol><li>#!/bin/bash</li>
<li>user=&rsquo;mark:x:0:0:this&nbsp;is&nbsp;a&nbsp;test&nbsp;user:/var/mark:nologin&rsquo;</li>
<li>i=1</li>
<li>while((1==1))</li>
<li>do</li>
<li>split=`echo&nbsp;$user|cut&nbsp;-d&nbsp;":"&nbsp;-f$i`</li>
<li>if&nbsp;[&nbsp;"$split"&nbsp;!=&nbsp;""&nbsp;]</li>
<li>then</li>
<li>((i++))</li>
<li>echo&nbsp;$split</li>
<li>else</li>
<li>break</li>
<li>fi</li>
<li>done</li></ol>
</div>

<p>这种方法不需要知道分隔后的字符串的个数，具有更好的通用性</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zygzv9.html">初步认识Less</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4j3y5q.html">关于HTML5 Audio线程问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5l4yq.html">Java中Map常用方法总结以及遍历方式的汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ew5px8.html">dojo GridX 用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k42k69.html">精通Web Analytics 2&period;0 （4） 第二章：选择你的网络分析灵魂伴侣的最佳策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw6pv8.html">Scala 深入浅出实战经典 第40讲：Set、Map、TreeSet、TreeMap操作代码实战</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx77lv9.html">Python 元组知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnl5md8.html">什么是Nib文件&quest;&lpar;Nib文件是一种特殊类型的资源文件，它用于保存iPhone OS或Mac OS X应用程序的用户接口&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0dm48.html">依赖注入框架Autofac的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y7xy3q.html">js 判断对象相等</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y764z8.html">node&period;js     fs&period;open 和 fs&period;write    读取文件和改写文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyx3lm9.html">CentOS ifconfig无IP地址解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4lk59.html">mybatis分页&plus;springmvc&plus;jsp&plus;maven使用步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjz4738.html">java虚拟机的类加载机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q255e2lq.html">ZOJ Problem Set - 2397 Tian Ji -- The Horse Racing</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy03xgq.html">《mysql必知必会》学习&lowbar;第17章&lowbar;20180807&lowbar;欢</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m20eg2q.html">Dom操作注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd167v9.html">Typecho 调用分类文章列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o417xlq.html">Splunk Web页面的登录密码忘记了怎么办</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p300jq.html">nodeJS &plus; webStrome</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq1d70qg.html">jquery库和cityselect插 件的省市 级联</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k4069j.html">static，你还敢用吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn0vg9r.html">Windows 10 安装SVN 不显示状态图标--解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyn0d9r.html">Php基础知识测试题</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4v20qz.html">【分布式】Zookeeper请求处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gvlz97.html">1&period;JAVA之GUI编程概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kew58j.html">react入门（3）</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q75pj9e.html">&period;NET跨平台之旅：将QPS 100左右的ASP&period;NET Core站点部署到Linux服务器上</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd2009d.html">JavaScript易错知识点整理</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq40k38z.html">定向爬虫 - Python模拟新浪微博登录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
